//+------------------------------------------------------------------+
//|                                             # BuySell_Filter.mq4 |
//|                                        Copyright  2008, masemus |
//|                                                 Gresik@Indonesia |
//+------------------------------------------------------------------+
#property copyright "masemus"
#property link      "masemus@yahoo.com"

#property indicator_separate_window
#property indicator_maximum 1.2
#property indicator_minimum -0.2
#property indicator_buffers 7
#property indicator_color1 C'255,206,215'
#property indicator_color2 C'255,234,238'
#property indicator_color3 C'220,250,220'
#property indicator_color4 C'180,245,180'
#property indicator_color5 DeepPink
#property indicator_color6 LimeGreen
#property indicator_color7 DarkGray

#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 5
#property indicator_width4 5

extern int TF             = 0;

//---- input parameters
extern int MA1Period      = 1;
extern int MA1_Shift      = 0;
extern int MA1_Method     = 0;
extern int MA1_Price_Type = 0;
extern int MA2Period      = 3;
extern int MA2_Shift      = 0;
extern int MA2_Method     = 0;
extern int MA2_Price_Type = 0;
extern int MA3Period      = 13;
extern int MA3_Shift      = 0;
extern int MA3_Method     = 0;
extern int MA3_Price_Type = 0;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double UpBuffer1[];
double DnBuffer1[];
double SwBuffer1[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  SetIndexStyle(0,DRAW_HISTOGRAM);
  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexStyle(1,DRAW_HISTOGRAM);
  SetIndexBuffer(1,ExtMapBuffer2);
  SetIndexStyle(2,DRAW_HISTOGRAM);
  SetIndexBuffer(2,ExtMapBuffer3);
  SetIndexStyle(3,DRAW_HISTOGRAM);
  SetIndexBuffer(3,ExtMapBuffer4);

  SetIndexStyle(4,DRAW_ARROW);
  SetIndexStyle(5,DRAW_ARROW);
  SetIndexStyle(6,DRAW_ARROW);
  SetIndexBuffer(4,DnBuffer1);
  SetIndexBuffer(5,UpBuffer1);
  SetIndexBuffer(6,SwBuffer1);
  SetIndexArrow(4,108);
  SetIndexArrow(5,108);
  SetIndexArrow(6,108);

  SetIndexLabel(0,NULL); SetIndexLabel(1,NULL); SetIndexLabel(2,NULL);
  SetIndexLabel(3,NULL); SetIndexLabel(4,NULL); SetIndexLabel(5,NULL);
  SetIndexLabel(6,NULL);

//+------------------------------------------------------------------+
   string MTF="";
   double cTF=Period();

               if (cTF==PERIOD_M1) { MTF="M1"; }
               if (cTF==PERIOD_M5) { MTF="M5"; }
               if (cTF==PERIOD_M15) { MTF="M15"; }
               if (cTF==PERIOD_M30) { MTF="M30"; }
               if (cTF==PERIOD_H1) { MTF="H1"; }
               if (cTF==PERIOD_H4) { MTF="H4"; }
               if (cTF==PERIOD_D1) { MTF="D1"; }
               if (cTF==PERIOD_W1) { MTF="W1"; }
               if (cTF==PERIOD_MN1) { MTF="MN1"; }

               else if (TF == 1) { MTF="M1"; }
               else if (TF == 5) { MTF="M5"; }
               else if (TF == 15) { MTF="M15"; }
               else if (TF == 30) { MTF="M30"; }
               else if (TF == 60) { MTF="H1"; }
               else if (TF == 240) { MTF="H4"; }
               else if (TF == 1440) { MTF="D1"; }
               else if (TF == 10080) { MTF="W1"; }
               else if (TF == 43200) { MTF="MN1"; }

  IndicatorShortName(":: BuySell "+MTF+"");  

 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int      i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
  
     limit = Bars-counted_bars;

   for( i=limit; i>=0; i--)
   {
   
   ExtMapBuffer1[i]=0.0;
   ExtMapBuffer2[i]=0.0;
   ExtMapBuffer3[i]=0.0;
   ExtMapBuffer4[i]=0.0;
   
   double MA1 = iMA(Symbol(),TF,MA1Period,MA1_Shift,MA1_Method,MA1_Price_Type,i);
   double MA2 = iMA(Symbol(),TF,MA2Period,MA2_Shift,MA2_Method,MA2_Price_Type,i);
   double MA3 = iMA(Symbol(),TF,MA3Period,MA3_Shift,MA3_Method,MA3_Price_Type,i);

   double pMA1 = iMA(Symbol(),TF,MA1Period,MA1_Shift,MA1_Method,MA1_Price_Type,i+1);

   if(MA1>MA2 && MA1>MA3)ExtMapBuffer4[i] = 1;
   if(MA1<=MA2 && MA1>MA3){ExtMapBuffer2[i] = 1;}
   if(MA1>=MA2 && MA1<MA3)ExtMapBuffer3[i] = 1;
   if(MA1<MA2 && MA1<MA3){ExtMapBuffer1[i] = 1;}

   //Price
   double Harga = iMA(Symbol(),TF,1,0,MODE_EMA,PRICE_CLOSE,i);   
   double pHarga = iMA(Symbol(),TF,1,0,MODE_EMA,PRICE_CLOSE,i+1);   
   double Open_o = iOpen(NULL,TF,i);
   double or = iHigh(NULL,TF,i+1) - iLow(NULL,TF,i+1);
   double oR = (iHigh(NULL,TF,i+1) + iLow(NULL,TF,i+1))/2;
   double oP = (iHigh(NULL,TF,i+1) + iLow(NULL,TF,i+1) + iClose(NULL,TF,i+1))/3;
   double Midnol = (Open_o + oP)/2;

   //Market
  
     if ((Harga > oP) && (Harga > Open_o)) {UpBuffer1[i] = 0.5;}
     else if ((Harga < oP) && (Harga < Open_o)) {DnBuffer1[i] = 0.5;}
          else {SwBuffer1[i] = 0.5;}

  }
 
 
 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+